#ifndef _merge_sort_h
#define _merge_sort_h
/**
 * =====================================================================================
 * @file merge_sort.h
 * @date 11 Jul 2005
 * @since 06/10/04 10:26:02 PDT
 * @author mfh
 * @version 1.0
 * 
 * A merge sort function with the same interface as `qsort()'.
 * =====================================================================================
 */
#ifdef HAVE_SYS_TYPES_H
#  include <sys/types.h> /* size_t */
#else
   typedef int size_t;
#endif



/** 
 * A merge sort function with the same interface as `qsort()'.  
 * Merge sort is a stable sort with guaranteed O(n lg n) runtime, 
 * unlike Quicksort.
 *
 * @param v [IN/OUT]   Array of elements to sort
 * @param nmemb [IN]   Number of elements in the array
 * @param size  [IN]   Size of each element in the array
 * @param compar [IN]  Sorting function (works like strcmp)
 */
void 
merge_sort (void* v, 
	    size_t nmemb,
	    size_t size,
	    int (*compar) (const void*, const void*));

#endif /* _merge_sort_h */
