#include <config.h>

#ifdef GETTIMEOFDAY_IN_SYS_TIME_H
#  include <sys/time.h>
#else
#  ifdef GETTIMEOFDAY_IN_TIME_H
#    include <time.h>
#  else
#    error "Which header file are you supposed to include for gettimeofday()?"
#  endif
#endif


void
deinit_timer()
{
  /* When using gettimeofday, there is no need to de-initialize the timer. */
}


double
get_seconds()
{
  struct timeval tp;
  int i;

  /* The POSIX standard (2003 edition) says that if the 2nd argument of
   * gettimeofday is not NULL, the behavior of the function is unspecified.
   */
  i = gettimeofday (&tp,0);
  return ( (double) tp.tv_sec + (double) tp.tv_usec * 1.e-6 );
}


void
init_timer()
{
  int i;
  double s = 0.0;
  double t;
  double x = 1.0;

  /*
   * MFH 2004 Jan 24: Sometimes gettimeofday doesn't work right on the
   * first call.  So I decided to put a "warmup run" here.  We time
   * some convergent operation which the compiler won't optimize away.
   */
  t = get_seconds();
  for (i = 0; i < 100000; i++)
    {
      s = s + x / 2;
      x = x / 2.0;
    }
  t = get_seconds() - t;
}











