/**
 * @file coord_elem.c
 * @author mfh
 * @since 26 May 2005
 */
#include <config.h>
#include <coord_elem.h>

#include <stdio.h>


void
print_coord_array_matrix (FILE* out, const struct coord_elem_t A[], const int nnz)
{
  int i;
  int max_col_idx = -1, max_row_idx = -1;

  /**
   * \bug (mfh 29 June 2004) Should really store m and n in the coordinate 
   * array data structure; otherwise it is necessary to have an explicit 
   * zero at (m-1,n-1) in order to get m and n.
   */
  /*
   * Find the number of rows and columns in the matrix, by finding the maximum
   * row and column indices.
   */
  if (nnz > 0)
    {
      for (i = 0; i < nnz; i++)
	{
	  const struct coord_elem_t curelem = A[i];

	  if (curelem.r > max_row_idx) max_row_idx = curelem.r;
	  if (curelem.r > max_col_idx) max_col_idx = curelem.c;
	}
    }

  fprintf (out, "%%%%MatrixMarket matrix coordinate real general\n");
  fprintf (out, "%d %d %d\n", max_row_idx + 1, max_col_idx + 1, nnz);

  for (i = 0; i < nnz; i++)
    fprintf (out, "%d %d %g\n", A[i].r, A[i].c, A[i].val);
}


