#ifndef _coord_elem_h
#define _coord_elem_h
/**
 * @file coord_elem.h
 * @author mfh
 * @since 26 May 2006
 */

#include <stdio.h> /* FILE */

/** 
 * A single element of a ``coordinate array'' sparse matrix.  It is similar to
 * COO format, except that it uses the ``array of structs'' (as opposed to
 * ``struct of arrays'') storage paradigm.  An array of coord_elem_t represents
 * a sparse matrix, each of whose entries is represented by a single
 * coord_elem_t.
 */
struct
coord_elem_t
{
  /** Row index of the element */
  int r;
  
  /** Column index of the element */
  int c;
  
  /** Value of the element */
  double val;
};


/**
 * Prints the given sparse matrix, stored as a coordinate array, to the given
 * file stream, in MatrixMarket format.
 */
void
print_coord_array_matrix (FILE* out, const struct coord_elem_t A[], const int nnz);




#endif /* _coord_elem_h */
