#ifndef _smvm_hpcc_interface_h
#define _smvm_hpcc_interface_h
/**
 * @file smvm_hpcc_interface.h
 * @author mfh
 * @since 2004 Oct 02
 * @date 2004 Dec 23
 *
 * Interface to the SpMV benchmark which is exposed to the HPC Challenge 
 * benchmark suite.  Given a properly constructed parameters object, this
 * function calls the benchmark and sends results to the appropriate file
 * and/or output device.
 ****************************************************************************/
#include "hpcc.h"  /* Proxy for HPCC interface */

/**
 * Calls the register-blocked sparse matrix-vector multiplication benchmark,
 * using the given parameters.
 * 
 * @param params [IN/OUT]  Supplies 
 *         parameters for the benchmark, and returns results.  
 * @return Error code (zero if no errors, else nonzero).  This is redundant 
 *         since the appropriate entry in params for our benchmark also stores
 *         the error code, but it models the interfaces of other benchmarks.
 */
int
smvm_hpcc_interface (struct my_HPCC_Params* params);



#endif /* NOT _smvm_hpcc_interface_h */
