#ifndef _smvm_memory_hierarchy_traits_h
#define _smvm_memory_hierarchy_traits_h
/**
 * @file smvm_memory_hierarchy_traits.h
 * @author mfh
 * @date Time-stamp: <2004-03-23 09:48:47 mhoemmen>
 * 
 * A struct that expresses the memory hierarchy traits of the environment.
 ****************************************************************************/

/**
 * Expresses traits of the current system's memory hierarchy.
 */
struct SMVM_memory_hierarchy_traits
{
  /** 
   * Max memory for use by sparse matrix and vectors in benchmark.
   * 
   * Maximum ``available'' memory in KB that we can allocate for the BSR sparse matrix
   * and the source and destination vectors.  It governs the dimensions of the matrix.
   */
  int max_allocable_mem; 
};


/**
 * Initializes the given (non-NULL) object with the given data.
 *
 * @param p_memtraits [OUT]  To be initialized with the parameters below.
 * @param maxmem [IN]  Max amount (in KB) of memory available for the matrix 
 *                     and source and destination vectors.
 */
void
smvm_init_memory_hierarchy_traits (struct SMVM_memory_hierarchy_traits* p_memtraits, 
				   int maxmem);





#endif /* _smvm_memory_hierarchy_traits_h */

